BEGIN { push(@INC,".."); 
};
# запрос ппараметров COM-портов в системе
sub LoadKrugSettings()
{
  my $FILE;
  open(FILE,"</gsw/etc/krug.env") or die "$!";
  my %data = ();
   while(<FILE>)
  {
    chomp ($_);
    if(/(\.*)\=(\.*)/)
    {
        my $tmp = "$'";
        $data{"$`"}=$tmp;
        undef $tmp;
    }
  }
  undef @output;
  close (FILE);
  return %data;
}
#сохранить данные в файл 
# переаметры - хеш с пользовательскими данными
sub Save()
{
  my (%userdata) = @_;
  my %settings = LoadKrugSettings();
  my $path=$settings{"GSW_SETTINGS"}."krugkntr.ini";
  my %filedata = ParseKrugKntrIniFile($settings{"GSW_SETTINGS"}."krugkntr.ini");
  foreach my $section (keys %userdata)
  {
    foreach my $param (keys %{$userdata{$section}})
    {      
      $filedata{$section}{$param}=$userdata{$section}{$param};
    }
  };
 my $OUTFILE;
 open(OUTFILE, ">/tmp/krugkntr.ini") or die print "sdfsdfsdfsdf";

  foreach my $section (keys %filedata)
  {
    my $s=$section;
    print OUTFILE $s,"\n";
    foreach my $param (keys %{$filedata{$section}})
    {
      my $v=$filedata{$section}{$param};
      my $p = $param;  
      print OUTFILE $p,"=",$v,"\n";
    }
  } 
  close(OUTFILE); 
   $out=`iconv -f utf-8 -t cp866 /tmp/krugkntr.ini -o $path`;
}


# считать данные из файла конфигураций
sub ParseKrugKntrIniFile()
{
 my %settings = LoadKrugSettings();
 my $filename = $settings{"GSW_SETTINGS"}."krugkntr.ini";
 my %data = GetIniFileData($filename);
 return %data;
};
#чтение файлов конфигураций интерфейсов(interface.config)
sub ParseInterfaceConfig()
{
 my ($filename1)=@_;
 my %Data=();
 %Data = GetIniFileData($filename1);
 my %Return_Data=() ;
 for my $section (keys %Data)
 {
   for my $param (keys %{$Data{$section}})
   {
     my $Sect = "[".$Data{$section}{'Section'}."]";
     my $Par = $Data{$section}{'Param'};
     $Return_Data{$Sect}{$Par}{$param} = $Data{$section}{$param};
   }
 };
 return %Return_Data; 
}

sub GetSectionFilesInfo()
{
 my ($filename) = @_;
 my $groupFilename=$filename;
 $groupFilename=~s/\.sect/\.group/g;
 my %sectiondata = GetIniFileData($filename);
 my %groupdata=GetIniFileData($groupFilename);
 my %data=();

 foreach $sectionGroup (keys %groupdata)
 {
 	my $secGroupName=$groupdata{$sectionGroup}{'Name'};
 	$data{$secGroupName}{'Order'}=$groupdata{$sectionGroup}{'Order'};
 	$data{$secGroupName}{'Caption'}=$groupdata{$sectionGroup}{'Caption'};
 	foreach $section (keys %sectiondata)
 	{
 	  if($sectiondata{$section}{'Group'} eq $secGroupName)
 	  {
 	    %{$data{$secGroupName}{'Sections'}{$section}}=%{$sectiondata{$section}}; 	    
 	  }	
 	} 	 	 	
 }
 return %data;
}

# парсер файлов конфигураций
sub GetIniFileData()
{ 
 my ($filename) = @_;
 my $INIFILE;
 my $section;
 my %Data=();
 my $filenametmp=$filename;
 $filenametmp=~s/\/.*\//\/tmp\//;
 
 $out=`rm -f $filenametmp; iconv -f cp866 -t utf-8 $filename -o $filenametmp`;
 if(open(INIFILE, "<$filenametmp")!=0) 
 {
 while(<INIFILE>)
 {
   chomp;
   $_=~s/:.*//g;    

   if(/\[.+?\]/)  
   {     
     $section = $_;
   }
   if(/(\.*)\=(\.*)/)
   {  
     $s ="$`";    
     $s=~s/:.*//g;
     my $s1="$'";   
     $Data{$section}{$s} = $s1;  
   }  
 }
 close(INIFILE);
 } 
 return %Data; 
   
}
sub str_Length()
{
 my ($str)=@_;	
 use Encode;
 $str=~s/%.*?%/ /g;
 $str=decode('utf8', $str);
 return length($str);	
}
1;



